Qwt User's Guide: QwtPlotPicker Class Reference

- Main Page
- Classes
- Files
- Related Pages

- Alphabetical List
- Class List
- Class Hierarchy
- Class Members

# QwtPlotPicker Class Reference

Inheritance diagram for QwtPlotPicker:

[legend]
Collaboration diagram for QwtPlotPicker:

[legend]
List of all members.

## Detailed Description

QwtPlotPicker provides selections on a plot canvas.

QwtPlotPicker is a QwtPicker tailored for selections on a plot canvas. It is set to a x-Axis and y-Axis and translates all pixel coordinates into this coodinate system.

Definition at line 29 of file qwt_plot_picker.h.

## Signals
void | selected (const QwtDoublePoint &pos)
void | selected (const QwtDoubleRect &rect)
void | selected (const QwtArray< QwtDoublePoint > &pa)
void | appended (const QwtDoublePoint &pos)
void | moved (const QwtDoublePoint &pos)
## Public Member Functions
| QwtPlotPicker (QwtPlotCanvas *)
| QwtPlotPicker (int xAxis, int yAxis, QwtPlotCanvas *)
| QwtPlotPicker (int xAxis, int yAxis, int selectionFlags, RubberBand rubberBand, DisplayMode trackerMode, QwtPlotCanvas *)
virtual void | setAxis (int xAxis, int yAxis)
int | xAxis () const
int | yAxis () const
QwtPlot * | plot ()
const QwtPlot * | plot () const
QwtPlotCanvas * | canvas ()
const QwtPlotCanvas * | canvas () const
## Protected Member Functions
QwtDoubleRect | scaleRect () const
QwtDoubleRect | invTransform (const QRect &) const
QRect | transform (const QwtDoubleRect &) const
QwtDoublePoint | invTransform (const QPoint &) const
QPoint | transform (const QwtDoublePoint &) const
virtual QwtText | trackerText (const QPoint &) const
virtual QwtText | trackerText (const QwtDoublePoint &) const
virtual void | move (const QPoint &)
virtual void | append (const QPoint &)
virtual bool | end (bool ok=true)

## Constructor & Destructor Documentation

QwtPlotPicker::QwtPlotPicker | ( | QwtPlotCanvas * | canvas | ) | `[explicit]`

  | Create a plot picker. The picker is set to those x- and y-axis of the plot that are enabled. If both or no x-axis are enabled, the picker is set to QwtPlot::xBottom. If both or no y-axis are enabled, it is set to QwtPlot::yLeft. Parameters:
  | canvas | Plot canvas to observe, also the parent object
See also: QwtPlot::autoReplot(), QwtPlot::replot(), QwtPlotPicker::scaleRect() Definition at line 32 of file qwt_plot_picker.cpp. References QwtPlot::axisEnabled(), canvas(), plot(), and xAxis().

QwtPlotPicker::QwtPlotPicker | ( | int | xAxis,
|  | int | yAxis,
|  | QwtPlotCanvas * | canvas
| ) | `[explicit]`

  | Create a plot picker Parameters:
  | xAxis | Set the x axis of the picker
  | yAxis | Set the y axis of the picker
  | canvas | Plot canvas to observe, also the parent object
See also: QwtPlot::autoReplot(), QwtPlot::replot(), QwtPlotPicker::scaleRect() Definition at line 70 of file qwt_plot_picker.cpp.

QwtPlotPicker::QwtPlotPicker | ( | int | xAxis,
|  | int | yAxis,
|  | int | selectionFlags,
|  | RubberBand | rubberBand,
|  | DisplayMode | trackerMode,
|  | QwtPlotCanvas * | canvas
| ) | `[explicit]`

  | Create a plot picker Parameters:
  | xAxis | X axis of the picker
  | yAxis | Y axis of the picker
  | selectionFlags | Or'd value of SelectionType, RectSelectionType and SelectionMode
  | rubberBand | Rubberband style
  | trackerMode | Tracker mode
  | canvas | Plot canvas to observe, also the parent object
See also: QwtPicker, QwtPicker::setSelectionFlags(), QwtPicker::setRubberBand(), QwtPicker::setTrackerMode QwtPlot::autoReplot(), QwtPlot::replot(), QwtPlotPicker::scaleRect() Definition at line 93 of file qwt_plot_picker.cpp.

## Member Function Documentation

void QwtPlotPicker::append | ( | const QPoint & | pos | ) | `[protected, virtual]`

  | Append a point to the selection and update rubberband and tracker. Parameters:
  | pos | Additional point
See also: isActive, begin(), end(), move(), appended() Note: The appended(const QPoint &), appended(const QDoublePoint &) signals are emitted. Reimplemented from QwtPicker. Definition at line 244 of file qwt_plot_picker.cpp. References QwtPicker::append(), appended(), and invTransform().

void QwtPlotPicker::appended | ( | const QwtDoublePoint & | pos | ) | `[signal]`

  | A signal emitted when a point has been appended to the selection Parameters:
  | pos | Position of the appended point.
See also: append(). moved() Referenced by append().

const QwtPlotCanvas * QwtPlotPicker::canvas | ( |  | ) | const

| Return Observed plot canvas. Definition at line 113 of file qwt_plot_picker.cpp.

QwtPlotCanvas * QwtPlotPicker::canvas | ( |  | ) |

| Return observed plot canvas. Definition at line 103 of file qwt_plot_picker.cpp. References QwtPicker::parentWidget(). Referenced by plot(), QwtPlotPicker(), and QwtPlotZoomer::QwtPlotZoomer().

bool QwtPlotPicker::end | ( | bool | ok = `true` | ) | `[protected, virtual]`

  | Close a selection setting the state to inactive. Parameters:
  | ok | If true, complete the selection and emit selected signals otherwise discard the selection.
Returns: true if the selection is accepted, false otherwise Reimplemented from QwtPicker. Reimplemented in QwtPlotZoomer. Definition at line 273 of file qwt_plot_picker.cpp. References QwtPicker::end(), invTransform(), plot(), selected(), QwtPicker::selection(), and QwtPicker::selectionFlags(). Referenced by QwtPlotZoomer::end().

QwtDoublePoint QwtPlotPicker::invTransform | ( | const QPoint & | pos | ) | const`[protected]`

| Translate a point from pixel into plot coordinates Returns: Point in plot coordinates See also: QwtPlotPicker::transform() Definition at line 369 of file qwt_plot_picker.cpp. References QwtPlot::canvasMap(), QwtScaleMap::invTransform(), and plot().

QwtDoubleRect QwtPlotPicker::invTransform | ( | const QRect & | rect | ) | const`[protected]`

| Translate a rectangle from pixel into plot coordinates Returns: Rectangle in plot coordinates See also: QwtPlotPicker::transform() Definition at line 332 of file qwt_plot_picker.cpp. References QwtPlot::canvasMap(), QwtScaleMap::invTransform(), and plot(). Referenced by append(), QwtPlotZoomer::end(), end(), move(), and trackerText().

void QwtPlotPicker::move | ( | const QPoint & | pos | ) | `[protected, virtual]`

  | Move the last point of the selection Parameters:
  | pos | New position
See also: isActive, begin(), end(), append() Note: The moved(const QPoint &), moved(const QDoublePoint &) signals are emitted. Reimplemented from QwtPicker. Definition at line 259 of file qwt_plot_picker.cpp. References invTransform(), QwtPicker::move(), and moved().

void QwtPlotPicker::moved | ( | const QwtDoublePoint & | pos | ) | `[signal]`

  | A signal emitted whenever the last appended point of the selection has been moved. Parameters:
  | pos | Position of the moved last point of the selection.
See also: move(), appended() Referenced by move().

const QwtPlot * QwtPlotPicker::plot | ( |  | ) | const

| Return plot widget, containing the observed plot canvas. Definition at line 133 of file qwt_plot_picker.cpp.

QwtPlot * QwtPlotPicker::plot | ( |  | ) |

| Return plot widget, containing the observed plot canvas. Definition at line 119 of file qwt_plot_picker.cpp. References canvas(). Referenced by QwtPlotZoomer::end(), end(), invTransform(), QwtPlotPicker(), QwtPlotZoomer::rescale(), scaleRect(), setAxis(), QwtPlotZoomer::setZoomBase(), and transform().

QwtDoubleRect QwtPlotPicker::scaleRect | ( |  | ) | const`[protected]`

| Return normalized bounding rect of the axes See also: QwtPlot::autoReplot(), QwtPlot::replot(). Definition at line 143 of file qwt_plot_picker.cpp. References QwtPlot::axisScaleDiv(), QwtScaleDiv::lBound(), plot(), QwtScaleDiv::range(), xAxis(), and yAxis(). Referenced by QwtPlotZoomer::rescale(), QwtPlotZoomer::setAxis(), and QwtPlotZoomer::setZoomBase().

void QwtPlotPicker::selected | ( | const QwtArray< QwtDoublePoint > & | pa | ) | `[signal]`

  | A signal emitting the selected points, at the end of a selection. Parameters:
  | pa | Selected points

void QwtPlotPicker::selected | ( | const QwtDoubleRect & | rect | ) | `[signal]`

  | A signal emitted in case of selectionFlags() & RectSelection. Parameters:
  | rect | Selected rectangle

void QwtPlotPicker::selected | ( | const QwtDoublePoint & | pos | ) | `[signal]`

  | A signal emitted in case of selectionFlags() & PointSelection. Parameters:
  | pos | Selected point
Referenced by end().

void QwtPlotPicker::setAxis | ( | int | xAxis,
|  | int | yAxis
| ) | `[virtual]`

  | Set the x and y axes of the picker Parameters:
  | xAxis | X axis
  | yAxis | Y axis
Reimplemented in QwtPlotZoomer. Definition at line 169 of file qwt_plot_picker.cpp. References plot(). Referenced by QwtPlotZoomer::setAxis().

QwtText QwtPlotPicker::trackerText | ( | const QwtDoublePoint & | pos | ) | const`[protected, virtual]`

  | Translate a position into a position string. In case of HLineRubberBand the label is the value of the y position, in case of VLineRubberBand the value of the x position. Otherwise the label contains x and y position separated by a ',' . The format for the double to string conversion is "%.4f". Parameters:
  | pos | Position
Returns: Position string Definition at line 217 of file qwt_plot_picker.cpp. References QwtPicker::rubberBand().

QwtText QwtPlotPicker::trackerText | ( | const QPoint & | pos | ) | const`[protected, virtual]`

  | Translate a pixel position into a position string Parameters:
  | pos | Position in pixel coordinates
Returns: Position string Reimplemented from QwtPicker. Definition at line 200 of file qwt_plot_picker.cpp. References invTransform().

QPoint QwtPlotPicker::transform | ( | const QwtDoublePoint & | pos | ) | const`[protected]`

| Translate a point from plot into pixel coordinates Returns: Point in pixel coordinates See also: QwtPlotPicker::invTransform() Definition at line 385 of file qwt_plot_picker.cpp. References QwtPlot::canvasMap(), plot(), and QwtScaleMap::transform().

QRect QwtPlotPicker::transform | ( | const QwtDoubleRect & | rect | ) | const`[protected]`

| Translate a rectangle from plot into pixel coordinates Returns: Rectangle in pixel coordinates See also: QwtPlotPicker::invTransform() Definition at line 351 of file qwt_plot_picker.cpp. References QwtPlot::canvasMap(), plot(), and QwtScaleMap::transform().

int QwtPlotPicker::xAxis | ( |  | ) | const

| Return x axis. Definition at line 183 of file qwt_plot_picker.cpp. Referenced by QwtPlotPicker(), QwtPlotZoomer::rescale(), scaleRect(), and QwtPlotZoomer::setAxis().

int QwtPlotPicker::yAxis | ( |  | ) | const

| Return y axis. Definition at line 189 of file qwt_plot_picker.cpp. Referenced by QwtPlotZoomer::rescale(), scaleRect(), and QwtPlotZoomer::setAxis().